"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.loaderResolver = loaderResolver;
exports.moduleResolver = moduleResolver;

var _constants = require("../constants");

var _libAlias = require("./libAlias");

var _client_packages_group = require("@zohodesk/client_packages_group");

function moduleResolver(options) {
  const {
    moduleResolvePath,
    disableES5Transpile
  } = options.app;
  const nodeModulesPath = moduleResolvePath ? require(require.resolve(moduleResolvePath, {
    paths: [options.cwd]
  })).nodeModulesPath : _client_packages_group.nodeModulesPath; // const {unstableDepsInverse} = options;

  return {
    modules: [nodeModulesPath, _constants.cliNodemodulesPath, 'node_modules'].filter(Boolean),
    alias: disableES5Transpile ? _libAlias.libAlias : {} // alias: { ...libAlias, ...clientDependenies }

  };
}

function loaderResolver(options) {
  // const unstableDepsInverse = false;
  const {
    unstableDepsInverse
  } = options;
  return {
    modules: unstableDepsInverse ? ['node_modules', _constants.cliNodemodulesPath] : [_constants.cliNodemodulesPath, 'node_modules'] // alias:  libAlias

  };
}