"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _caseSensitivePathsWebpackPlugin = _interopRequireDefault(require("case-sensitive-paths-webpack-plugin"));

var _miniCssExtractPlugin = _interopRequireDefault(require("mini-css-extract-plugin"));

var _plugins = require("../plugins");

var _webpack = _interopRequireDefault(require("webpack"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let getUMDCSSPlugins = () => {
  let plugins = [new _caseSensitivePathsWebpackPlugin.default(), new _webpack.default.DefinePlugin({
    __TEST__: false,
    __DEVELOPMENT__: false,
    __DOCS__: false,
    'process.env': {
      NODE_ENV: JSON.stringify('production')
    },
    __SERVER__: false
  }), new _miniCssExtractPlugin.default({
    filename: 'css/[name].css',
    chunkFilename: 'css/[id].css'
  }), new _plugins.UglifyCSSPlugin()];
  return plugins;
};

var _default = getUMDCSSPlugins;
exports.default = _default;