"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getI18nKeysFormModules;

var _I18nDependency = require("../I18nDependency");

function getI18nKeysFormModules(modules) {
  const i18nTemObj = {};

  for (let m of modules) {
    for (let dep of m.dependencies) {
      if (!(dep instanceof _I18nDependency.I18nDependency)) {
        continue;
      }

      for (const key of dep.i18nKeys) {
        i18nTemObj[key] = 1;
      }
    }
  }

  return Object.keys(i18nTemObj);
}