"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getCliPath = getCliPath;

var _path = _interopRequireDefault(require("path"));

var _os = require("os");

var _fs = require("fs");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const appPath = process.cwd();
const isNodeModuleUnderAppFolder = __dirname.indexOf(appPath) !== -1;
const isWindows = (0, _os.platform)().toLowerCase() === 'win32';

const _getCliPath = !isNodeModuleUnderAppFolder ? libName => _path.default.join(__dirname, '..', '..', 'node_modules', '.bin', libName) : libName => libName;

const suffixExt = isWindows ? '.cmd' : '';

function getCliPath(libName) {
  const cliPath = _getCliPath(libName + suffixExt);

  return (0, _fs.existsSync)(cliPath) ? cliPath : libName + suffixExt;
}