"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.httpsOptions = httpsOptions;
exports.httpsOptionsWithUserFriendlyError = httpsOptionsWithUserFriendlyError;

// import fs from 'fs';
// import path from 'path';
// export const httpsOptions = {
//   key: fs.readFileSync(path.join(__dirname, './cert/Tsicsezwild-22-23.key')),
//   cert: fs.readFileSync(path.join(__dirname, './cert/Tsicsezwild-22-23.crt'))
// };
function httpsOptions(options) {
  const {
    httpsCerts
  } = options.app.server;

  const certificate = require(require.resolve(httpsCerts, {
    paths: [process.cwd()]
  })); // TODO: in future we may do some version based check. certificate.version


  return certificate.httpsOptions;
}

function httpsOptionsWithUserFriendlyError(options) {
  const {
    httpsCerts
  } = options.app.server;

  if (typeof httpsCerts === 'string' && httpsCerts) {
    try {
      const certificate = httpsOptions(options);
      return certificate;
    } catch (error) {
      if (error.message.indexOf('Cannot find module') !== -1) {
        console.error(`You have given react-cli.app.server.httpsCerts as "${httpsCerts}". \n But it seems that file path have some problem.\n we are unable to locate "${httpsCerts}" in "${process.cwd()}"`);
      } else {
        console.error(error);
      }

      process.exit(0);
    }
  } else {
    return null;
  }
}